<!--
    Original overlay code and implementation by SimpleAOB
    Contact:
        Discord - SimpleAOB#9999 (preferred)
        Email - simple(@at)bakkesplugins(dot)com
    Credits:
        BakkesWebApi by gboddin - Heavily modified and extended by SimpleAOB
            - Now available at: https://gitlab.com/bakkesplugins/sos/sos-plugin
-->

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>SOS - Rocket League OBS Browser Source Overlay</title>
    <style>
        ${require('../out/css/main.min.css')}
    </style>
</head>
<body>
    <div class="page-container">
        <div class="waiting-for-websocket">
            <div class="technical-difficulties hidden"></div>
            <div class="text">
                Waiting for Websocket Server to connect...
            </div>
        </div>
        <div class="teams left">
            <div class="logo-color-bg" style="background-color: #00E1FF"></div>
            <div class="shape-cover">
                <svg  xmlns="http://www.w3.org/2000/svg" width="42px" height="147px">
                    <rect fill-rule="evenodd"  fill="rgb(255, 255, 255)" width="42" height="147"/>
                </svg>
            </div>
            <div class="logo">
                <img class="logo-img">
            </div>
            <div class="name"></div>
        </div>
        <div class="teams right">
            <div class="logo-color-bg" style="background-color: #e2012d"></div>
            <div class="shape-cover">
                <svg xmlns="http://www.w3.org/2000/svg" width="42px" height="147px">
                    <rect fill-rule="evenodd" class="edge-shape"  fill="rgb(255, 255, 255)" width="42" height="147"/>
                </svg>
            </div>
            <div class="logo">
                <img class="logo-img">
            </div>
            <div class="name"></div>
        </div>
    </div>
    <script>${require('vendor/jquery-3.4.1/jquery-3.4.1.min.js')}</script>
    <script>${require('../out/js/base.js')}</script>
    <script>
        //!!! Register the websocket listeners before attempting to connect
        WsSubscribers.subscribe("ws", "open", function() {
            $(".waiting-for-websocket").addClass("hidden");
            WsSubscribers.send("cb", "first_connect", {
                'name': 'Highlights',
                'version': ${require('../version.txt')}
            });
            setInterval(function () {
                WsSubscribers.send("cb", "heartbeat", "heartbeat");
            }, 1000);
        });

        WsSubscribers.subscribe("ws", "open", function() {
            $(".waiting-for-websocket").addClass("hidden");
        });

        WsSubscribers.subscribe("ws", "error", function() {
            $(".waiting-for-websocket .text").text("[002] There has been an error with the Rocket League connection. Please stand by");
            $(".waiting-for-websocket").removeClass("hidden");
        });

        WsSubscribers.subscribe("ws", "close", function() {
            $(".waiting-for-websocket .text").text("[004] Connection to Rocket League has gone away. Please stand by");
            $(".waiting-for-websocket, .technical-difficulties").removeClass("hidden");
        });

        WsSubscribers.init(49322, false, [
            "game:update_tick",
            "cb:heartbeat"
        ]);
    </script>
    <script>
        let teamMap = ${require('../../team_logos/map.json')};
        WsSubscribers.subscribe("sos", "up_next_teams_update", (d) => {
            let leftLower = d.left.name.toLowerCase();
            let rightLower = d.right.name.toLowerCase();

            if (teamMap.hasOwnProperty(leftLower)) {
                let teamLeft = teamMap[leftLower];
                $('.teams.left .logo-img').attr('src', `../team_logos/${teamLeft.logo}`);
                $('.teams.left .logo-color-bg').css('background-color', teamLeft.background);
                if (teamLeft.black_text) {
                    $('.teams.left .name').css('color', 'black');
                } else {
                    $('.teams.left .name').css('color', 'white');
                }
            } else {
                $('.teams.left .logo-img').attr('src', `../team_logos/DEFAULT.png`);
                $('.teams.left .logo-color-bg').css('background-color', '#0090d3');
                $('.teams.left .name').css('color', 'white');
            }

            if (teamMap.hasOwnProperty(rightLower)) {
                let teamRight = teamMap[rightLower];
                $('.teams.right .logo-img').attr('src', `../team_logos/${teamRight.logo}`);
                $('.teams.right .logo-color-bg').css('background-color', teamRight.background);
                if (teamRight.black_text) {
                    $('.teams.right .name').css('color', 'black');
                } else {
                    $('.teams.right .name').css('color', 'white');
                }
            } else {
                $('.teams.right .logo-img').attr('src', `../team_logos/DEFAULT.png`);
                $('.teams.right .logo-color-bg').css('background-color', '#f26522');
                $('.teams.right .name').css('color', 'white');
            }

            $('.teams.left .name').text(d.left.name);
            $('.teams.right .name').text(d.right.name);

            SOSUtils.fitText('.teams .name', 45);
        });
    </script>
    <script>${require('sos-plugins/testing/js/testing.js')}</script>
</body>
</html>